/*--------------------------------
------Rollup Like a Boss
--------------------------------*/

--School Active Student totals
SELECT SC, COUNT(*)[Total]
FROM STU
WHERE DEL = 0 AND TG = ''
GROUP BY ROLLUP (SC)

--School and Grade Active Student totals
SELECT SC, GR, COUNT(*)[Total]
FROM STU
WHERE DEL = 0 AND TG = ''
GROUP BY ROLLUP (SC,GR)


--CON COUNTS with Rollup
SELECT PID,
  ISNULL(RL, 'Total') 'Relationship', 
  CONVERT(VARCHAR(10), [Count with Rollup]) 'Record Count'
FROM 
 (SELECT ISNULL(CONVERT(VARCHAR(15), PID), 'Grand') PID,
 CONVERT(VARCHAR(10), RL) RL,
 COUNT(*) 'Count with Rollup' 
FROM CON 
WHERE DEL = 0 
--AND RL NOT IN (10,11)
--AND PID IN (SELECT ID FROM STU WHERE SC = 994)  -- another example of a subquery
GROUP BY ROLLUP (PID, RL)) C


