/*--------------------------------
------ Variables
--------------------------------*/

--Global Variables

select @@version

select @@servername

--Connections since last restart
SELECT GETDATE() AS 'Today''s Date and Time', 
@@CONNECTIONS AS 'Login Attempts'

--Declare a very basic variable
declare @SC as int = 994

select sc, id, fn, tg 
from stu
where sc = @SC

--Use a variable in the where clause
declare @cityMask as nvarchar(100) = 'Rock'

select * from stu where cy like '%' + @cityMask + '%'

------use variables to calculate enrollment
DECLARE @FirstDay AS DATETIME = '07/04/2023' --(SELECT MIN(DT) FROM DAY WHERE DEL = 0 AND HO IN (''))
DECLARE @Lastday AS DATETIME = '08/04/2024' --(SELECT MAX(DT) FROM DAY WHERE DEL = 0 AND HO IN (''))
DECLARE @EnrYear AS NVARCHAR(4) = '2023'

SELECT STU.SC, STU.SN, STU.ID, ENR.ED, ENR.LD,
(SELECT COUNT(DAY.DT) FROM DAY WHERE day.dt >= @FirstDay 
  AND DAY.DT <= @Lastday 
  AND DAY.SC = STU.SC 
  AND DAY.HO = '' 
  AND DAY.DT >= ENR.ED 
  AND DAY.DT <= ISNULL(ENR.LD, @Lastday)) AS DaysENR,
(SELECT COUNT(ATT.DT) FROM ATT INNER JOIN ABS ON ATT.SC = ABS.SC AND ATT.AL = ABS.CD WHERE ATT.DT >= @Firstday 
  AND ATT.DT <= @Lastday 
  AND ATT.DEL = 0 
  AND ABS.AD = 0 
  AND ATT.DT >= ENR.ED 
  AND ATT.DT <= ISNULL(ENR.LD, @Lastday) 
  AND ATT.SC = STU.SC AND ATT.SN = STU.SN) AS DaysAbs,
(SELECT COUNT(DAY.DT) FROM DAY WHERE day.dt >= @FirstDay 
  AND DAY.DT <= @Lastday 
  AND DAY.SC = STU.SC 
  AND DAY.HO = '' 
  AND DAY.DT >= ENR.ED 
  AND DAY.DT <= ISNULL(ENR.LD, @Lastday)) - 
(SELECT COUNT(ATT.DT) FROM ATT INNER JOIN ABS ON ATT.SC = ABS.SC AND ATT.AL = ABS.CD WHERE ATT.DT >= @Firstday 
  AND ATT.DT <= @Lastday 
  AND ATT.DEL = 0 
  AND ABS.AD = 0 
  AND ATT.DT >= ENR.ED 
  AND ATT.DT <= ISNULL(ENR.LD, @Lastday) 
  AND ATT.SC = STU.SC AND ATT.SN = STU.SN) AS DaysPresent
FROM STU INNER JOIN ENR ON STU.SC = ENR.SC AND STU.SN = ENR.SN
WHERE ENR.YR = @EnrYear AND STU.DEL= 0 AND ENR.DEL = 0